package spoke.misc.learning;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class LearningH extends Applet implements ActionListener, AdjustmentListener, Timeable {
	static final int N=10;
	static final int M=3000;
	transient Timer timer=new Timer(this,1000/N);
	Scrollbar sb;
	double dt=1.0/(double)N;
	double theta;
	double u;
	double x_;
	double dx;
	double l=0.03;
	double g=.098;
	double f=.004;
	double m=.01;
	int pos2;
	int pos1;
	int pos;
	int lg;

	Canvas can=new Canvas() {
		public void paint(Graphics g) {
			Dimension s=getSize();
			int xo=s.width/2+(int)(x_*(double)M);
			int yo=s.height/2;
			int xa=s.width/2+(int)((Math.cos(theta)*l+x_)*(double)M);
			int ya=s.height/2-(int)(Math.sin(theta)*l*(double)M);
			g.drawLine(xo,yo,xa,ya);
		}
	};

	public void init() {
		setLayout(new GridBagLayout());
		GridBagConstraints c=new GridBagConstraints();
		c.fill=GridBagConstraints.BOTH;
		c.gridx=0;
		c.gridy=0;
		c.weightx=1.;
		c.weighty=1.;
		add(can,c);
		sb=new Scrollbar();
		sb.addAdjustmentListener(this);
		sb.setOrientation(Scrollbar.HORIZONTAL);
		Dimension size=getSize();
		setLg(size.width);
		sb.setMaximum(lg+sb.getVisibleAmount()-1);
		sb.setValue(lg/2);
		c.gridx=0;
		c.gridy=1;
		c.weightx=0.;
		c.weighty=0.;
		add(sb,c);
		Panel panel=new Panel();
		Button start=new Button("Start");
		start.addActionListener(this);
		panel.add(start);
		Button stop=new Button("Stop");
		stop.addActionListener(this);
		panel.add(stop);
		c.gridx=0;
		c.gridy=3;
		c.weightx=0.;
		c.weighty=0.;
		add(panel,c);
		reset();
	}

	void setLg(int lg) {
		this.lg=lg;
	}

	void reset() {
		pos=lg/2;
		pos1=pos;
		pos2=pos;
		theta=-Math.PI/2.;
		u=0.0;
		x_=0.0;
		dx=0.0;
	}

	public void stop() {
		timer.stop();
	}

	public void actionPerformed(ActionEvent e) {
		String cmd=e.getActionCommand();
		if(cmd.equals("Start")) {
			timer.cont();
		} else if(cmd.equals("Stop")) {
			timer.stop();
		}
	}

	public void adjustmentValueChanged(AdjustmentEvent e) {
		pos=e.getValue();
	}

	public void tick(Timer t) {
		double d2x=compute();
		double dtheta=u*dt;
//		double du=((m*Math.sin(theta)*d2x/(dt*dt)-f*l*u+f*Math.sin(theta)*dx/dt-g*m*Math.cos(theta))/(l*m))*dt;
		double du=((m*Math.sin(theta)*d2x/(dt*dt)-f*l*u-g*m*Math.cos(theta))/(l*m))*dt;
		theta+=dtheta;
		u+=du;
		dx+=d2x;
		x_+=dx;
		can.repaint();
	}

	double compute() {
		double d2x=(double)((pos-pos1)-(pos1-pos2))/(double)M;
		pos2=pos1;
		pos1=pos;
		return d2x;
	}

	boolean isUp() {
		return Math.sin(theta)>0.;
	}
}
